# Axis to Scrollwheel - a plugin for Joystick Gremlin

This is a plugin for [Joystick Gremlin](https://github.com/WhiteMagic/JoystickGremlin) (JG). Familiarity with JG is assumed.

This script will allow you to configure a joystick axis to send mouse scrollwheel events. The scrollwheel will move faster in proportion to how far the axis is moved.

## Installation

Download the code (TODO: add granular instructions). Click "Add Plugin" on the Plugins tab of Joystick Gremlin. Navigate to the axis_to_scrollwheel.py file and select it.

## Configuration

Clicking on the gear next to the plugin in the plugin list will present you with several configuration options. Note that you must toggle the profile off and on again for changes to take effect.

### Axis

The axis that should act as a scrollwheel.

### Mode

The Joystick Gremlin mode that needs to be active for the binding to work. If you aren't using Modes (or don't know what they are) the default value should work correctly.

### Scroll Speed

Increasing this value will cause the scroll wheel to scroll more quickly. 1.0 is a good default.

### Deadzone

This deadzone will take precedence over any deadzone already configured in Joystick Gremlin. 1.0 represents the joystick's entire range. 0.0 represents no deadzone.

### Invert

If the scrolling feels backwards, select this.

## Known Issues

* The Response Coefficient doesn't always get assigned a default value. You should set it to `1.0` to start.
* Maxing out the axis in either direction will cause the scrolling to stop. This is a limitation of Joystick Gremlin; it stops producing joystick axis events in this case. Ideally we could use a periodic check instead of responding to axis events, but this is currently broken (see https://github.com/WhiteMagic/JoystickGremlin/issues/239).